// +-------------------------------------------------+
// © 2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: actionZone.js,v 1.32 2017-02-16 09:25:08 ngantier Exp $

define(['dojo/_base/declare', 'dojo/dom', 'dijit/_Widget', 'dojo/topic', 'dojo/_base/lang', 'dijit/registry', 'dijit/form/Button', "dojo/dom-construct", "dijit/registry", "app/warningMessage", "dojox/dtl/_base", "dojox/dtl/Context", "app/workZone"], function(declare, dom, widget, topic, lang, registry, Button, domConstruct, registry, warningMessage, dtl, Context, workZone) {
    return declare(widget, {

        params : null,
        exitButton : null,
        checkoutButton : null,
        printTicketButton : null,
        backButton : null,
        bookingButton : null,
        buttonDiv : null,
        workContainer : null,
        postCreate : function() {

            /** Abonnement aux évenements provenants de la classe "readerDatas" **/
            this.own(topic.subscribe("readerDatas", lang.hitch(this, this.handleEvents)), topic.subscribe("contentZone", lang.hitch(this, this.handleEvents)), topic.subscribe("actionZone", lang.hitch(this, this.handleEvents)));
            this.params = dojoConfig.bibloto.appParams;

            /** Instanciation/Création de la div contenant les différents boutons de controle **/
            this.buttonDiv = domConstruct.create('div', {
                id : 'contentButton',
                class : 'contentButton',
                style : {
                    margin : '0 auto',
                    width : '50%'
                }
            }, this.domNode);

            this.initButtons();

            /** Instanciation/Création de la div contenant les messages relatifs à une action + le bouton terminer (terminer l'action) **/
            this.workContainer = new workZone(this.domNode);
        },

        handleEvents : function(evtType, evtArgs) {
            //console.debug('evt received in actionZone', evtType, evtArgs);
            switch (evtType) {
            case 'contentReady':
                /**
                 * Action selon le paramétrage
                 * voir reader datas pour le mode enabled by default ? apres les datas user reçues
                 */
                switch(this.params.default_action) {
                case '0':
                    //Cas affichage boutons par défault

                    break;
                case '1':
                    //Cas affichage prêts directs
                    this.checkout();
                    break;
                case '2':
                    //Cas affichage retour direct
                    this.checkin();
                    break;
                case '3':
                    //Cas d'affichage des résas direct
                    this.book();
                    break;
                }
                break;
            case 'erase':
                if (dojoConfig.bibloto.appParams.default_action_end == 0)
                    this.endAction();
                topic.publish('actionZone', 'actionZoneErased');
                (this.params.msg_action_title) ? dom.byId('infoState').innerHTML = "<span>" + this.params.msg_action_title + "</span>" : dom.byId('infoState').innerHTML = "";
                break;
            }
        },

        /** Instanciation des différents boutons de controle en fonction du paramétrage de l'appli **/
        initButtons : function() {
            if (parseInt(this.params.checkout_activate)) {

                /** Creation du bouton emprunter un livre **/
                this.checkoutButton = new Button({
                    label : this.params.msg_checkout_button,
                    onClick : lang.hitch(this, this.checkout),
                }, domConstruct.create('div', {
                    id : 'checkoutButton'
                }, this.buttonDiv)).startup();

            }
            //console.log('resa activate', this.params.resa_activate, 'params', this.params);
            if (parseInt(this.params.resa_activate)) {

                /** Création du bouton réserver un livre **/
                this.bookingButton = new Button({
                    label : this.params.msg_resa_button,
                    onClick : lang.hitch(this, this.book),
                }, domConstruct.create('div', {
                    id : 'bookingButton'
                }, this.buttonDiv)).startup();
            }
            if (parseInt(this.params.checkin_activate)) {

                /** Création du bouton rendre un livre **/
                this.backButton = new Button({
                    label : this.params.msg_checkin_button,
                    onClick : lang.hitch(this, this.checkin),
                }, domConstruct.create('div', {
                    id : 'checkinButton'
                }, this.buttonDiv)).startup();
            }
            /*
            if (this.params.printer_activate) {
            this.printTicketButton = new Button({
            label : this.params.msg_printer_button,
            onClick : lang.hitch(this, this.printTicket),
            }, domConstruct.create('div', {
            id : 'printTicketButton'
            }, this.buttonDiv)).startup();

            }*/
            /** Création du bouton exit (publie un evt -> clean datas empr + retour homepage) **/
            this.exitButton = new Button({
                label : this.params.msg_exit_button,
                onClick : lang.hitch(this, this.backHomepage),
            }, domConstruct.create('div', {
                id : 'exitButton'
            }, this.buttonDiv)).startup();
            (this.params.msg_action_title) ? dom.byId('infoState').innerHTML = "<span>" + this.params.msg_action_title + "</span>" : dom.byId('infoState').innerHTML = "";
            //TODO: Se baser sur les parametres fourni par la source pour instancier les bon boutons en fonction des droits
        },

        /** Fonction appelée lors du retour à la page d'accueil **/
        backHomepage : function() {
            //Publish event, nettoyage des différents parametres renseignés + back to homepage
            topic.publish('actionZone', 'erase');
        	document.getElementById("keyboard").focus();
        },

        /** Fonction des prêts **/
        checkout : function() {
            /**
             * Faire un prêt
             * Publication d'un event change mode + enable lecture cb pour pret ///// Affichage du panneau "Présentez un exemplaire"
             */

            this.hideContainers();
            var loanActionDatas = registry.byId('loanActionDatas');
            loanActionDatas.resetDatas();
            loanActionDatas.domNode.style.display = "";
            loanActionDatas.render();
            this.buttonDiv.style.display = "none";
            this.workContainer.show();
            this.setMessage(this.params.msg_dialog_place_item_checkout);

            (this.params.msg_checkout_title) ? dom.byId('infoState').innerHTML = "<span>" + this.params.msg_checkout_title + "</span>" : dom.byId('infoState').innerHTML = '';
            topic.publish('actionZone', 'enableLoan');

        	document.getElementById("keyboard").focus();
        },

        /** Fonction d'impression ticket **/
        printTicket : function() {
            /**
             * Faire l'impression du ticket
             */
            //console.debug(this.params.printer_tpl);
            //console.debug(dojoConfig.bibloto.readerDatas.emprInfos);
            //  var template = new dtl.Template(this.params.printer_tpl);
            templateObj = new dtl.Template(this.params.printer_tpl);
            contextObj = new Context(dojoConfig.bibloto.readerDatas.emprInfos);
            compiledTemplate = templateObj.render(contextObj);
            var applet = document.jzebra;
            if (applet != null) {
                this.printer_finding(applet, compiledTemplate);
            }
        },

        printer_finding : function(applet, text) {
            //console.debug(text);
            applet.findPrinter(this.params.printer_name);
            if (!applet.isDoneFinding()) {
                //window.setTimeout(lang.hitch(this, this.printer_finding(applet,text), 100));
                //console.debug('printer not found (isDoneFinding)');
                return;
            }
            if (applet.getPrinter()) {
                applet.setEncoding(850);
                applet.append(text);
                applet.print();
            } else {
                //console.debug('printer not found (getPrinter)');
            }
        },

        /** Fonction des retours **/
        checkin : function() {
            this.hideContainers();
            var containerback = registry.byId('backDatas');
            containerback.resetDatas();
            containerback.domNode.style.display = "";
            containerback.render();
            this.buttonDiv.style.display = "none";
            this.workContainer.show();
            this.setMessage(this.params.msg_dialog_place_item_checkin);
            (this.params.msg_checkin_title) ? dom.byId('infoState').innerHTML = "<span>" + this.params.msg_checkin_title + "</span>" : dom.byId('infoState').innerHTML = '';
            topic.publish('actionZone', 'enableBack');

        	document.getElementById("keyboard").focus();
        },

        /** Affichage de l'écran des réservations **/
        book : function() {
            this.hideContainers();
            var resaDatas = registry.byId('resaDatas');
            resaDatas.domNode.style.display = "";

            (this.params.msg_resa_title) ? dom.byId('infoState').innerHTML = "<span>" + this.params.msg_resa_title + "</span>" : dom.byId('infoState').innerHTML = "";
            resaDatas.render();
        },

        /** Set le message de la zone d'action **/
        setMessage : function(msg, error) {
            this.workContainer.setMsg(msg, error);
        },

        /** Fonction de masquage des dontainers loanDatas & resaDatas (en fct du paramétrage) **/
        hideContainers : function() {
            if (parseInt(this.params.checkin_activate)) {
                if (registry.byId('loanDatas'))
                    registry.byId('loanDatas').domNode.style.display = "none";
                if (registry.byId('loanActionDatas'))
                    registry.byId('loanActionDatas').domNode.style.display = "none";
            }
            if (parseInt(this.params.resa_activate)) {
                if (registry.byId('resaDatas'))
                    registry.byId('resaDatas').domNode.style.display = "none";
            }
            if (parseInt(this.params.checkout_activate)) {
                if (registry.byId('backDatas'))
                    registry.byId('backDatas').domNode.style.display = "none";
            }
        },

        /**
         * Fct éxecutée à l'appui sur le bouton terminer
         * -> arrête l'écoute et masque le workContainer (affichage de l'expl posé sur la platine + boutons décisionnels)
         */
        endAction : function() {
            topic.publish('actionZone', 'stopListen');
            this.buttonDiv.style.display = "";
            this.workContainer.hide();
            this.hideContainers();

            /** Switch selon le parametre défini dans le connecteur **/
            if (this.params.default_action_end == 0) {
                var loanDatas = registry.byId('loanDatas');
                loanDatas.domNode.style.display = "";
                loanDatas.render();
                registry.byId('mainContainer').resize();
                (this.params.msg_action_title) ? dom.byId('infoState').innerHTML = "<span>" + this.params.msg_action_title + "</span>" : dom.byId('infoState').innerHTML = "";
            } else {
                //(this.params.msg_action_title)?dom.byId('infoState').innerHTML="<span>"+this.params.msg_action_title+"</span>":dom.byId('infoState').innerHTML="";
                this.backHomepage();
            }
        },
    });
});
