// +-------------------------------------------------+
// © 2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: resaContainer.js,v 1.8 2015-06-12 15:02:09 vtouchard Exp $

define(["dojo/_base/declare", "dojox/grid/DataGrid", "dojo/topic", "dojo/_base/lang", "dojo/dom-construct", "dijit/registry", "dojo/store/Memory", "dojo/data/ObjectStore", "dojo/dom"], function(declare, DataGrid, topic, lang, domConstruct, registry, Memory, ObjectStore, dom) {
    return declare(null, {
        dataGrid : null,
        resaStore : null,
        datasResa : null,
        readingEnabled : true,
        constructor : function() {
            /**
             * Création du store de prêt
             * Instanciation du datagrid
             *
             */
            this.datasResa = new Array();

            for (var i = 0; i < dojoConfig.bibloto.readerDatas.emprInfos.reservations.length; i++) {
                this.datasResa.push({
                    "title" : dojoConfig.bibloto.readerDatas.emprInfos.reservations[i].title,
                    "resa_date" : dojoConfig.bibloto.readerDatas.emprInfos.reservations[i].date,
                    'resa_confirmed' : (dojoConfig.bibloto.readerDatas.emprInfos.reservations[i].confirmee == 1) ? 'Oui' : 'Non'
                });
            }

            //this.datasLoan = {'items': {'items':this.datasLoan}};

            this.resaStore = new ObjectStore({
                objectStore : new Memory({
                    data : this.datasResa
                })
            });

            this.dataGrid = new DataGrid({
                autoHeight : true,
                store : this.resaStore,
                query : {
                    id : "*"
                },
                structure : [{
                    name : "Titre",
                    field : "title",
                    editable : false,
                    width : "40%"
                }, {
                    name : "Date",
                    field : "resa_date",
                    editable : false,
                    width : "30%"
                }, {
                    name : "Confirmée",
                    field : "resa_confirmed",
                    editable : false,
                    width : "30%"
                }]
            }, domConstruct.create('div', {
                id : 'resaDatas',
                style : {
                    height : '300px',
                    width : 'auto',
                }
            }, registry.byId('contentZone').domNode));

            this.dataGrid.startup();
            // topic.subscribe('actionZone', lang.hitch(this, this.handleEvents));
        },
    });
});
