// +-------------------------------------------------+
// © 2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: warningMessage.js,v 1.6 2015-06-12 15:02:09 vtouchard Exp $

define(["dojo/_base/declare", "dojo/topic", "dojo/_base/lang", "dijit/Dialog", "dojo/dom", "dijit/form/Button"], function(declare, topic, lang, Dialog, dom, Button) {
    return declare(null, {
        errorDialog : null,
        buttonClose : null,
        title : "",
        mode : "", //nom event à renvoyer pour reprendre la lecture dans le bon mode
        constructor : function(mode, warningMessage, title) {
            //console.log("warningMessage: "+this.warningMessage)
            this.title = title;
            if (dom.byId('dialogContent'))
                return;
            this.mode = mode;
            this.warningMessage = warningMessage;
            var closeWarningClosure = lang.hitch(this, this.closeFromHide);
            this.errorDialog = new Dialog({
                title : this.title,
                style : "width: 300px",
                content : "<div id='dialogContent' class='returnMessage'></div><div class='buttonClose' id='buttonClose'></div>",
                onHide : closeWarningClosure,
            });
            this.errorDialog.startup();
            this.buttonClose = new Button({
                label : "Fermer",
                onClick : lang.hitch(this, this.closeWarningMessages),
            }, 'buttonClose');

            this.buttonClose.startup();
            this.errorDialog.show();

            this.fillDialog();
            //this.warningMessage;
            play_single_sound("audioNOk");
        },

        /**
         * Permet quel que soit le mode de fermeture du
         * popup, de le supprimer
         * (touche échap; appui sur le bouton fermer; appui sur fermer)
         */
        closeWarningMessages : function() {
            this.errorDialog.hide();
        },

        closeFromHide : function() {
            this.buttonClose.destroy();
            this.errorDialog.destroy();
            this.errorDialog = null;
            this.buttonClose = null;
            topic.publish('warningMessage', this.mode);
        },

        /**
         * Crée une liste de message
         */
        fillDialog : function() {
            var content = "<ul>";
            if ( typeof this.warningMessage == "string") {
                content += "<li>" + this.warningMessage + "</li>";
            } else {
                for (var i = 0; i < this.warningMessage.length; i++) {
                    content += "<li>" + this.warningMessage[i] + "</li>";
                }
            }
            content += "</ul>";
            dom.byId('dialogContent').innerHTML = content;
        },
    });
});
